package hal

import (
	"context"
	"github.com/stretchr/testify/assert"
	"testing"
)

func TestCluster_Run(t *testing.T) {
	var mapping ModuleMapping

	firstModule := &Module{
		programStorage: map[int64]*ProgrammedInstruction{
			1: {
				Instruction: InstructionStart,
			},
		},
		register: []float64{0},
		IO:       map[int64]IO{},
	}
	secondModule := &Module{
		programStorage: map[int64]*ProgrammedInstruction{
			1: {
				Instruction: InstructionStop,
			},
		},
		register: []float64{0},
		IO:       map[int64]IO{},
	}

	mapping = map[MultiThreadedIOPort]MultiThreadedIOPort{
		{
			Module: firstModule,
			IOPort: 0,
		}: {
			Module: secondModule,
			IOPort: 0,
		},
	}
	assert.NoError(t, mapping.BuildCluster().Run(context.Background()))
}
